<template>
    <section>
        <Notificacao 
            v-if="getState.notificacao.show"
        />        
        <div class="cabecalho-login">
            <material-icon type="mdi" :path="mdiLockOpenCheckOutline" size=40 /> Login
        </div>
        <form autocomplete="off">

          <div class="field">
              <label class="label">E-mail</label>
              <div class="control">
                  <input class="input" type="email" placeholder="Digite seu e-mail" v-model="state.form.email">
              </div>
          </div>

          <div class="field">
              <label class="label">Password</label>
              <div class="control">
                  <input class="input" type="password" placeholder="Senha" v-model="state.form.password">
              </div>
          </div>

          <div class="buttons">
              <button class="button" @click="$router.push({ name: 'home' })">
                  <material-icon type="mdi" :path="mdiArrowLeft" size="20" />
              </button>
              <button class="button is-success" @click.prevent="login">Entrar</button>
          </div>

          <div class="buttons cadastro">
              <button class="button is-success" @click="$router.push({ name: 'cadastro' })">Não possui cadastro</button>
          </div>

        </form>{{state}}
    </section>
</template>
<script>
import { mdiLockOpenCheckOutline, mdiArrowLeft } from '@mdi/js';
import { requestPOST } from '@/services/http/index'
import { getState, setNotificacao } from '@/store/index'
import { reactive } from '@vue/reactivity';
import Notificacao from '../modules/bulma/Notificacao.vue'
import sessao from '../../services/sessao'

export default {
    components: {
        Notificacao
    },
    setup() {
        const state = reactive({
            form: {}
        })
        const login = () => {
            requestPOST(`${getState.env.VUE_APP_URL_API_LOJA}/login`, state.form)
              .then(response => {
                  console.log(response.data);
                  if (response.status === 200) {
                    setNotificacao({
                        show: true,
                        mensagem: 'Sucesso!'
                    })
                    sessao.criarSessao(response.data)
                    location.href = '/'
                  } 
              }).catch(e => {
                  if (e.response.status === 401) {
                    setNotificacao({
                        show: true,
                        mensagem: 'Usuário ou senha incorretos'
                    })                      
                  } 
              })
        }

        return {
            mdiLockOpenCheckOutline,
            mdiArrowLeft,
            login,
            state,
            getState
        }
    },
}
</script>

<style scoped>
    section {
        max-width: 30em;
        margin: auto;
        display: flex;
        box-shadow: #00000073 1px 4px 16px 0px;
        background-color: #00000003;
        padding: 15px;
        margin-top: 5em;
        flex-direction: column;
    }
    .buttons {
        display: flex;
        justify-content: space-between;
        margin-top: 1em;
        margin-bottom: 1em;
    }
    .cadastro button {
        width: 100%;
    }
    .cabecalho-login {
        margin: auto;
        margin-top: .7em;
        margin-bottom: .7em;
        display: flex;
        align-items: center;
        justify-content: space-between;
        width: 4.2em;
        font-size: 2em;
    }
</style>
